/** @file grab_client.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.1
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef GRAB_CLIENT_CMDLINE_H
#define GRAB_CLIENT_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef GRAB_CLIENT_CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define GRAB_CLIENT_CMDLINE_PARSER_PACKAGE "grab"
#endif

#ifndef GRAB_CLIENT_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define GRAB_CLIENT_CMDLINE_PARSER_VERSION "(paraslash 0.3.3, axiomatic perspectivity)"
#endif

/** @brief Where the command line options are stored */
struct grab_client_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int filter_num_arg;	/**< @brief point of filter chain to grab (default='0').  */
  char * filter_num_orig;	/**< @brief point of filter chain to grab original value given at command line.  */
  const char *filter_num_help; /**< @brief point of filter chain to grab help description.  */
  int slot_arg;	/**< @brief only grab this slot; grab any slot if negative (default='-1').  */
  char * slot_orig;	/**< @brief only grab this slot; grab any slot if negative original value given at command line.  */
  const char *slot_help; /**< @brief only grab this slot; grab any slot if negative help description.  */
  char * audio_format_arg;	/**< @brief only grab this type of input stream;
  	grab any if empty (default='').  */
  char * audio_format_orig;	/**< @brief only grab this type of input stream;
  	grab any if empty original value given at command line.  */
  const char *audio_format_help; /**< @brief only grab this type of input stream;
  	grab any if empty help description.  */
  int input_grab_flag;	/**< @brief grab the filter input instead of its output (default=off).  */
  const char *input_grab_help; /**< @brief grab the filter input instead of its output help description.  */
  int one_shot_flag;	/**< @brief stop grabbing if audio file changes (default=off).  */
  const char *one_shot_help; /**< @brief stop grabbing if audio file changes help description.  */
  char * mode_arg;	/**< @brief select grab mode (default='sloppy').  */
  char * mode_orig;	/**< @brief select grab mode original value given at command line.  */
  const char *mode_help; /**< @brief select grab mode help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int filter_num_given ;	/**< @brief Whether filter_num was given.  */
  unsigned int slot_given ;	/**< @brief Whether slot was given.  */
  unsigned int audio_format_given ;	/**< @brief Whether audio_format was given.  */
  unsigned int input_grab_given ;	/**< @brief Whether input_grab was given.  */
  unsigned int one_shot_given ;	/**< @brief Whether one_shot was given.  */
  unsigned int mode_given ;	/**< @brief Whether mode was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct grab_client_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure grab_client_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure grab_client_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *grab_client_args_info_purpose;
/** @brief the usage string of the program */
extern const char *grab_client_args_info_usage;
/** @brief all the lines making the help output */
extern const char *grab_client_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int grab_client_cmdline_parser (int argc, char * const *argv,
  struct grab_client_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use grab_client_cmdline_parser_ext() instead
 */
int grab_client_cmdline_parser2 (int argc, char * const *argv,
  struct grab_client_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int grab_client_cmdline_parser_ext (int argc, char * const *argv,
  struct grab_client_args_info *args_info,
  struct grab_client_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int grab_client_cmdline_parser_dump(FILE *outfile,
  struct grab_client_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int grab_client_cmdline_parser_file_save(const char *filename,
  struct grab_client_args_info *args_info);

/**
 * Print the help
 */
void grab_client_cmdline_parser_print_help(void);
/**
 * Print the version
 */
void grab_client_cmdline_parser_print_version(void);

/**
 * Initializes all the fields a grab_client_cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void grab_client_cmdline_parser_params_init(struct grab_client_cmdline_parser_params *params);

/**
 * Allocates dynamically a grab_client_cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized grab_client_cmdline_parser_params structure
 */
struct grab_client_cmdline_parser_params *grab_client_cmdline_parser_params_create(void);

/**
 * Initializes the passed grab_client_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void grab_client_cmdline_parser_init (struct grab_client_args_info *args_info);
/**
 * Deallocates the string fields of the grab_client_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void grab_client_cmdline_parser_free (struct grab_client_args_info *args_info);

/**
 * The string parser (interprets the passed string as a command line)
 * @param cmdline the command line stirng
 * @param args_info the structure where option information will be stored
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int grab_client_cmdline_parser_string (const char *cmdline, struct grab_client_args_info *args_info,
  const char *prog_name);
/**
 * The string parser (version with additional parameters - deprecated)
 * @param cmdline the command line stirng
 * @param args_info the structure where option information will be stored
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use grab_client_cmdline_parser_string_ext() instead
 */
int grab_client_cmdline_parser_string2 (const char *cmdline, struct grab_client_args_info *args_info,
  const char *prog_name,
  int override, int initialize, int check_required);
/**
 * The string parser (version with additional parameters)
 * @param cmdline the command line stirng
 * @param args_info the structure where option information will be stored
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int grab_client_cmdline_parser_string_ext (const char *cmdline, struct grab_client_args_info *args_info,
  const char *prog_name,
  struct grab_client_cmdline_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int grab_client_cmdline_parser_required (struct grab_client_args_info *args_info,
  const char *prog_name);

extern char *grab_client_cmdline_parser_mode_values[] ;	/**< @brief Possible values for mode.  */


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* GRAB_CLIENT_CMDLINE_H */
