/*
 * Copyright (C) 2006-2008 Andre Noll <maan@systemlinux.org>
 *
 * Licensed under the GPL v2. For licencing details see COPYING.
 */

/** \file stdin.h The standard in task structure. */

/** The task structure used for reading from stdin. */
struct stdin_task {
	/** Input buffer. */
	char *buf;
	/** The size of \a buf. */
	size_t bufsize;
	/** Number of bytes currently loaded in \a buf. */
	size_t loaded;
	/** Pointer to the error member of the consumer. */
	int *output_error;
	/** Whether \p STDIN_FILENO was included in the read fd set. */
	int check_fd;
	/** The task structure. */
	struct task task;
};

void stdin_set_defaults(struct stdin_task *sit);
