/*
 * Copyright (C) 2006-2008 Andre Noll <maan@systemlinux.org>
 *
 * Licensed under the GPL v2. For licencing details see COPYING.
 */

/** \file stdout.h The standard out task structure. */

/**
 * The task structure used for writing to stdout.
 */
struct stdout_task {
	/** Pointer to the data buffer. */
	char *buf;
	/** Number of bytes loaded in \a buf. */
	size_t *loaded;
	/** Pointer to the error variable of the feeding task. */
	int *input_error;
	/** The task structure. */
	struct task task;
	/** Whether \p STDOUT_FILENO was included in the write fd set. */
	int check_fd;
};

void stdout_set_defaults(struct stdout_task *sot);
