/*
 * Copyright (C) 2005-2008 Andre Noll <maan@systemlinux.org>
 *
 * Licensed under the GPL v2. For licencing details see COPYING.
 */

/** \file vss.h Exported functions from vss.c (para_server). */

void init_vss_task(int afs_socket);
unsigned int vss_playing(void);
unsigned int vss_next(void);
unsigned int vss_repos(void);
unsigned int vss_paused(void);
unsigned int vss_stopped(void);
struct timeval *vss_chunk_time(void);
const char *supported_audio_formats(void);

/** Stop playing after current audio file. */
#define VSS_NOMORE 1
/** Skip remaining part of current audio file. */
#define VSS_NEXT 2
/** A reposition request was sent by a client. */
#define VSS_REPOS 4
/** Currently playing. */
#define VSS_PLAYING 8
/** A client requested to change the audio file selector. */
#define VSS_CHANGE 16
