/** @file write.cmdline.h
 *  @brief The header file for the command line option parser
 *  generated by GNU Gengetopt version 2.22.1
 *  http://www.gnu.org/software/gengetopt.
 *  DO NOT modify this file, since it can be overwritten
 *  @author GNU Gengetopt by Lorenzo Bettini */

#ifndef WRITE_CMDLINE_H
#define WRITE_CMDLINE_H

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h> /* for FILE */

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef WRITE_CMDLINE_PARSER_PACKAGE
/** @brief the program name */
#define WRITE_CMDLINE_PARSER_PACKAGE "para_write"
#endif

#ifndef WRITE_CMDLINE_PARSER_VERSION
/** @brief the program version */
#define WRITE_CMDLINE_PARSER_VERSION "0.3.3"
#endif

/** @brief Where the command line options are stored */
struct write_args_info
{
  const char *help_help; /**< @brief Print help and exit help description.  */
  const char *version_help; /**< @brief Print version and exit help description.  */
  int list_writers_flag;	/**< @brief print available writers and exit (default=off).  */
  const char *list_writers_help; /**< @brief print available writers and exit help description.  */
  int loglevel_arg;	/**< @brief set loglevel (0-6) (default='4').  */
  char * loglevel_orig;	/**< @brief set loglevel (0-6) original value given at command line.  */
  const char *loglevel_help; /**< @brief set loglevel (0-6) help description.  */
  int bufsize_arg;	/**< @brief input buffer size (default='64').  */
  char * bufsize_orig;	/**< @brief input buffer size original value given at command line.  */
  const char *bufsize_help; /**< @brief input buffer size help description.  */
  char ** writer_arg;	/**< @brief select stream writer
  may be give multiple times. The same writer
  may be specified more than once (default='alsa (file if alsa is unsupported)').  */
  char ** writer_orig;	/**< @brief select stream writer
  may be give multiple times. The same writer
  may be specified more than once original value given at command line.  */
  unsigned int writer_min; /**< @brief select stream writer
  may be give multiple times. The same writer
  may be specified more than once's minimum occurreces */
  unsigned int writer_max; /**< @brief select stream writer
  may be give multiple times. The same writer
  may be specified more than once's maximum occurreces */
  const char *writer_help; /**< @brief select stream writer
  may be give multiple times. The same writer
  may be specified more than once help description.  */
  char * start_time_arg;	/**< @brief start playback at given time which must be
  in a:b format where a denotes seconds and b
  denotes microseconds since the epoch.  */
  char * start_time_orig;	/**< @brief start playback at given time which must be
  in a:b format where a denotes seconds and b
  denotes microseconds since the epoch original value given at command line.  */
  const char *start_time_help; /**< @brief start playback at given time which must be
  in a:b format where a denotes seconds and b
  denotes microseconds since the epoch help description.  */
  
  unsigned int help_given ;	/**< @brief Whether help was given.  */
  unsigned int version_given ;	/**< @brief Whether version was given.  */
  unsigned int list_writers_given ;	/**< @brief Whether list_writers was given.  */
  unsigned int loglevel_given ;	/**< @brief Whether loglevel was given.  */
  unsigned int bufsize_given ;	/**< @brief Whether bufsize was given.  */
  unsigned int writer_given ;	/**< @brief Whether writer was given.  */
  unsigned int start_time_given ;	/**< @brief Whether start_time was given.  */

} ;

/** @brief The additional parameters to pass to parser functions */
struct write_cmdline_parser_params
{
  int override; /**< @brief whether to override possibly already present options (default 0) */
  int initialize; /**< @brief whether to initialize the option structure write_args_info (default 1) */
  int check_required; /**< @brief whether to check that all required options were provided (default 1) */
  int check_ambiguity; /**< @brief whether to check for options already specified in the option structure write_args_info (default 0) */
  int print_errors; /**< @brief whether getopt_long should print an error message for a bad option (default 1) */
} ;

/** @brief the purpose string of the program */
extern const char *write_args_info_purpose;
/** @brief the usage string of the program */
extern const char *write_args_info_usage;
/** @brief all the lines making the help output */
extern const char *write_args_info_help[];

/**
 * The command line parser
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int write_cmdline_parser (int argc, char * const *argv,
  struct write_args_info *args_info);

/**
 * The command line parser (version with additional parameters - deprecated)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use write_cmdline_parser_ext() instead
 */
int write_cmdline_parser2 (int argc, char * const *argv,
  struct write_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The command line parser (version with additional parameters)
 * @param argc the number of command line options
 * @param argv the command line options
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int write_cmdline_parser_ext (int argc, char * const *argv,
  struct write_args_info *args_info,
  struct write_cmdline_parser_params *params);

/**
 * Save the contents of the option struct into an already open FILE stream.
 * @param outfile the stream where to dump options
 * @param args_info the option struct to dump
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int write_cmdline_parser_dump(FILE *outfile,
  struct write_args_info *args_info);

/**
 * Save the contents of the option struct into a (text) file.
 * This file can be read by the config file parser (if generated by gengetopt)
 * @param filename the file where to save
 * @param args_info the option struct to save
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int write_cmdline_parser_file_save(const char *filename,
  struct write_args_info *args_info);

/**
 * Print the help
 */
void write_cmdline_parser_print_help(void);
/**
 * Print the version
 */
void write_cmdline_parser_print_version(void);

/**
 * Initializes all the fields a write_cmdline_parser_params structure 
 * to their default values
 * @param params the structure to initialize
 */
void write_cmdline_parser_params_init(struct write_cmdline_parser_params *params);

/**
 * Allocates dynamically a write_cmdline_parser_params structure and initializes
 * all its fields to their default values
 * @return the created and initialized write_cmdline_parser_params structure
 */
struct write_cmdline_parser_params *write_cmdline_parser_params_create(void);

/**
 * Initializes the passed write_args_info structure's fields
 * (also set default values for options that have a default)
 * @param args_info the structure to initialize
 */
void write_cmdline_parser_init (struct write_args_info *args_info);
/**
 * Deallocates the string fields of the write_args_info structure
 * (but does not deallocate the structure itself)
 * @param args_info the structure to deallocate
 */
void write_cmdline_parser_free (struct write_args_info *args_info);

/**
 * The config file parser (deprecated version)
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param override whether to override possibly already present options
 * @param initialize whether to initialize the option structure my_args_info
 * @param check_required whether to check that all required options were provided
 * @return 0 if everything went fine, NON 0 if an error took place
 * @deprecated use write_cmdline_parser_config_file() instead
 */
int write_cmdline_parser_configfile (char * const filename,
  struct write_args_info *args_info,
  int override, int initialize, int check_required);

/**
 * The config file parser
 * @param filename the name of the config file
 * @param args_info the structure where option information will be stored
 * @param params additional parameters for the parser
 * @return 0 if everything went fine, NON 0 if an error took place
 */
int write_cmdline_parser_config_file (char * const filename,
  struct write_args_info *args_info,
  struct write_cmdline_parser_params *params);

/**
 * Checks that all the required options were specified
 * @param args_info the structure to check
 * @param prog_name the name of the program that will be used to print
 *   possible errors
 * @return
 */
int write_cmdline_parser_required (struct write_args_info *args_info,
  const char *prog_name);


#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* WRITE_CMDLINE_H */
